# Machine intelligence shapes our future. Let's shape it in our own image!

## Circo 1.0 whitepaper
**Draft**

*Krisztián Schäffer*, 

**Abstract.** 
Human-like artificial intelligence
would allow machines to act more naturally,
thus climb up from the uncanny walley[^uw]
on the right side.

![Uncanny Walley](https://upload.wikimedia.org/wikipedia/commons/thumb/f/f0/Mori_Uncanny_Valley.svg/1280px-Mori_Uncanny_Valley.svg.png)

The rise of deep learning initiated an era
where
human-level intelligence
seems to be within sight.
But
the perceptron model,
although
itself biologically inspired,
is
only a parody of the human brain.
Building on it alone
would
lead to zombies[^z] at best. 

We propose a solution based on structural similarity,
focusing on
physical compatibility in the low-level runtime
and
gradually refining
a biologically inspired model
on top of it.

Intelligence emerges
from the collective behavior
of independent actors
embedded in spacetime,
communicating by asynchronous message passing,
while
exchanging information
and energy.
Simulated spacetime is mapped to
computing hardware
dynamically for optimal execution.
Actors maintain their
identity and reputation,
used by
a decentralized judicial system
to enforce rules statistically.


[^uw] "*Uncanny valley* is a hypothesized relationship
between the degree of an object's resemblance to a human being
and the emotional response to such an object."
[Wikipedia](https://en.wikipedia.org/wiki/Uncanny_valley).

[^z] A philosophical zombie is
indistinguishable from a normal person
but does not have conscious experience.
[Wikipedia](https://en.wikipedia.org/wiki/Philosophical_zombie).
